/* This file has been generated from /home/steve/paparazzi/conf/airframes/examples/quad1.xml */
/* Please DO NOT EDIT */

#ifndef AIRFRAME_H
#define AIRFRAME_H

#define AIRFRAME_NAME "Quad_LisaM_2"
#define AC_ID 162
#define MD5SUM ((uint8_t*)"\310\154\032\342\312\351\001\333\342\374\206\374\167\346\120\021")

#define SERVOS_PWM_NB 4
#include "subsystems/actuators/actuators_pwm.h"

#define SERVO_FRONT 0
#define SERVO_FRONT_NEUTRAL 1100
#define SERVO_FRONT_TRAVEL_UP 0.0833333333333
#define SERVO_FRONT_TRAVEL_UP_NUM 1
#define SERVO_FRONT_TRAVEL_UP_DEN 12
#define SERVO_FRONT_TRAVEL_DOWN 0.0104166666667
#define SERVO_FRONT_TRAVEL_DOWN_NUM 1
#define SERVO_FRONT_TRAVEL_DOWN_DEN 96
#define SERVO_FRONT_MAX 1900
#define SERVO_FRONT_MIN 1000

#define SERVO_BACK 1
#define SERVO_BACK_NEUTRAL 1100
#define SERVO_BACK_TRAVEL_UP 0.0833333333333
#define SERVO_BACK_TRAVEL_UP_NUM 1
#define SERVO_BACK_TRAVEL_UP_DEN 12
#define SERVO_BACK_TRAVEL_DOWN 0.0104166666667
#define SERVO_BACK_TRAVEL_DOWN_NUM 1
#define SERVO_BACK_TRAVEL_DOWN_DEN 96
#define SERVO_BACK_MAX 1900
#define SERVO_BACK_MIN 1000

#define SERVO_RIGHT 2
#define SERVO_RIGHT_NEUTRAL 1100
#define SERVO_RIGHT_TRAVEL_UP 0.0833333333333
#define SERVO_RIGHT_TRAVEL_UP_NUM 1
#define SERVO_RIGHT_TRAVEL_UP_DEN 12
#define SERVO_RIGHT_TRAVEL_DOWN 0.0104166666667
#define SERVO_RIGHT_TRAVEL_DOWN_NUM 1
#define SERVO_RIGHT_TRAVEL_DOWN_DEN 96
#define SERVO_RIGHT_MAX 1900
#define SERVO_RIGHT_MIN 1000

#define SERVO_LEFT 3
#define SERVO_LEFT_NEUTRAL 1100
#define SERVO_LEFT_TRAVEL_UP 0.0833333333333
#define SERVO_LEFT_TRAVEL_UP_NUM 1
#define SERVO_LEFT_TRAVEL_UP_DEN 12
#define SERVO_LEFT_TRAVEL_DOWN 0.0104166666667
#define SERVO_LEFT_TRAVEL_DOWN_NUM 1
#define SERVO_LEFT_TRAVEL_DOWN_DEN 96
#define SERVO_LEFT_MAX 1900
#define SERVO_LEFT_MIN 1000


#define COMMAND_ROLL 0
#define COMMAND_PITCH 1
#define COMMAND_YAW 2
#define COMMAND_THRUST 3
#define COMMANDS_NB 4
#define COMMANDS_FAILSAFE {0,0,0,0}


#define SECTION_MIXING 1
#define MOTOR_MIXING_TRIM_ROLL 0
#define MOTOR_MIXING_TRIM_PITCH 0
#define MOTOR_MIXING_TRIM_YAW 0
#define MOTOR_MIXING_NB_MOTOR 4
#define MOTOR_MIXING_SCALE 256
#define MOTOR_MIXING_ROLL_COEF {    0,    0, -256,  256 }
#define MOTOR_MIXING_PITCH_COEF {  256, -256,    0,    0 }
#define MOTOR_MIXING_YAW_COEF { -256, -256,  256,  256 }
#define MOTOR_MIXING_THRUST_COEF {  256,  256,  256,  256 }

#define SERVO_BACK_IDX 0
#define Set_BACK_Servo(_v) { \
  actuators[SERVO_BACK_IDX] = Chop(_v, SERVO_BACK_MIN, SERVO_BACK_MAX); \
  ActuatorPwmSet(SERVO_BACK, actuators[SERVO_BACK_IDX]); \
}

#define SERVO_FRONT_IDX 1
#define Set_FRONT_Servo(_v) { \
  actuators[SERVO_FRONT_IDX] = Chop(_v, SERVO_FRONT_MIN, SERVO_FRONT_MAX); \
  ActuatorPwmSet(SERVO_FRONT, actuators[SERVO_FRONT_IDX]); \
}

#define SERVO_RIGHT_IDX 2
#define Set_RIGHT_Servo(_v) { \
  actuators[SERVO_RIGHT_IDX] = Chop(_v, SERVO_RIGHT_MIN, SERVO_RIGHT_MAX); \
  ActuatorPwmSet(SERVO_RIGHT, actuators[SERVO_RIGHT_IDX]); \
}

#define SERVO_LEFT_IDX 3
#define Set_LEFT_Servo(_v) { \
  actuators[SERVO_LEFT_IDX] = Chop(_v, SERVO_LEFT_MIN, SERVO_LEFT_MAX); \
  ActuatorPwmSet(SERVO_LEFT, actuators[SERVO_LEFT_IDX]); \
}

#define ACTUATORS_NB 4

#define SetActuatorsFromCommands(values, AP_MODE) { \
  int32_t servo_value;\
  int32_t command_value;\
\
  motor_mixing_run(autopilot_motors_on,FALSE,values); \
\
  command_value = motor_mixing.commands[SERVO_FRONT]; \
  command_value *= command_value>0 ? SERVO_FRONT_TRAVEL_UP_NUM : SERVO_FRONT_TRAVEL_DOWN_NUM; \
  command_value /= command_value>0 ? SERVO_FRONT_TRAVEL_UP_DEN : SERVO_FRONT_TRAVEL_DOWN_DEN; \
  servo_value = SERVO_FRONT_NEUTRAL + command_value; \
  Set_FRONT_Servo(servo_value); \
\
  command_value = motor_mixing.commands[SERVO_BACK]; \
  command_value *= command_value>0 ? SERVO_BACK_TRAVEL_UP_NUM : SERVO_BACK_TRAVEL_DOWN_NUM; \
  command_value /= command_value>0 ? SERVO_BACK_TRAVEL_UP_DEN : SERVO_BACK_TRAVEL_DOWN_DEN; \
  servo_value = SERVO_BACK_NEUTRAL + command_value; \
  Set_BACK_Servo(servo_value); \
\
  command_value = motor_mixing.commands[SERVO_RIGHT]; \
  command_value *= command_value>0 ? SERVO_RIGHT_TRAVEL_UP_NUM : SERVO_RIGHT_TRAVEL_DOWN_NUM; \
  command_value /= command_value>0 ? SERVO_RIGHT_TRAVEL_UP_DEN : SERVO_RIGHT_TRAVEL_DOWN_DEN; \
  servo_value = SERVO_RIGHT_NEUTRAL + command_value; \
  Set_RIGHT_Servo(servo_value); \
\
  command_value = motor_mixing.commands[SERVO_LEFT]; \
  command_value *= command_value>0 ? SERVO_LEFT_TRAVEL_UP_NUM : SERVO_LEFT_TRAVEL_DOWN_NUM; \
  command_value /= command_value>0 ? SERVO_LEFT_TRAVEL_UP_DEN : SERVO_LEFT_TRAVEL_DOWN_DEN; \
  servo_value = SERVO_LEFT_NEUTRAL + command_value; \
  Set_LEFT_Servo(servo_value); \
\
  ActuatorsPwmCommit();\
}

#define AllActuatorsInit() { \
  ActuatorsPwmInit();\
}

#define SECTION_IMU 1
#define IMU_ACCEL_X_NEUTRAL 11
#define IMU_ACCEL_Y_NEUTRAL 11
#define IMU_ACCEL_Z_NEUTRAL -25
#define IMU_MAG_X_NEUTRAL -179
#define IMU_MAG_Y_NEUTRAL -21
#define IMU_MAG_Z_NEUTRAL 79
#define IMU_MAG_X_SENS 4.17334785618
#define IMU_MAG_X_SENS_NUM 57467
#define IMU_MAG_X_SENS_DEN 13770
#define IMU_MAG_Y_SENS 3.98885954135
#define IMU_MAG_Y_SENS_NUM 34731
#define IMU_MAG_Y_SENS_DEN 8707
#define IMU_MAG_Z_SENS 4.40442339014
#define IMU_MAG_Z_SENS_NUM 2788
#define IMU_MAG_Z_SENS_DEN 633
#define IMU_BODY_TO_IMU_PHI 0.
#define IMU_BODY_TO_IMU_THETA 0.
#define IMU_BODY_TO_IMU_PSI 0.

#define SECTION_AHRS 1
#define AHRS_H_X 0.3770441
#define AHRS_H_Y 0.0193986
#define AHRS_H_Z 0.9259921

#define SECTION_INS 1
#define INS_BARO_SENS 22.3
#define INS_BARO_SENS_NUM 223
#define INS_BARO_SENS_DEN 10

#define SECTION_STABILIZATION_RATE 1
#define STABILIZATION_RATE_SP_MAX_P 10000
#define STABILIZATION_RATE_SP_MAX_Q 10000
#define STABILIZATION_RATE_SP_MAX_R 10000
#define STABILIZATION_RATE_DEADBAND_P 20
#define STABILIZATION_RATE_DEADBAND_Q 20
#define STABILIZATION_RATE_DEADBAND_R 200
#define STABILIZATION_RATE_REF_TAU 4
#define STABILIZATION_RATE_GAIN_P 400
#define STABILIZATION_RATE_GAIN_Q 400
#define STABILIZATION_RATE_GAIN_R 350
#define STABILIZATION_RATE_IGAIN_P 75
#define STABILIZATION_RATE_IGAIN_Q 75
#define STABILIZATION_RATE_IGAIN_R 50
#define STABILIZATION_RATE_DDGAIN_P 300
#define STABILIZATION_RATE_DDGAIN_Q 300
#define STABILIZATION_RATE_DDGAIN_R 300

#define SECTION_STABILIZATION_ATTITUDE 1
#define STABILIZATION_ATTITUDE_SP_MAX_PHI 0.7853981625
#define STABILIZATION_ATTITUDE_SP_MAX_THETA 0.7853981625
#define STABILIZATION_ATTITUDE_SP_MAX_R 1.570796325
#define STABILIZATION_ATTITUDE_DEADBAND_A 0
#define STABILIZATION_ATTITUDE_DEADBAND_E 0
#define STABILIZATION_ATTITUDE_DEADBAND_R 250
#define STABILIZATION_ATTITUDE_REF_OMEGA_P 13.962634
#define STABILIZATION_ATTITUDE_REF_ZETA_P 0.85
#define STABILIZATION_ATTITUDE_REF_MAX_P 6.981317
#define STABILIZATION_ATTITUDE_REF_MAX_PDOT RadOfDeg(8000.)
#define STABILIZATION_ATTITUDE_REF_OMEGA_Q 13.962634
#define STABILIZATION_ATTITUDE_REF_ZETA_Q 0.85
#define STABILIZATION_ATTITUDE_REF_MAX_Q 6.981317
#define STABILIZATION_ATTITUDE_REF_MAX_QDOT RadOfDeg(8000.)
#define STABILIZATION_ATTITUDE_REF_OMEGA_R 8.72664625
#define STABILIZATION_ATTITUDE_REF_ZETA_R 0.85
#define STABILIZATION_ATTITUDE_REF_MAX_R 3.14159265
#define STABILIZATION_ATTITUDE_REF_MAX_RDOT RadOfDeg(1800.)
#define STABILIZATION_ATTITUDE_PHI_PGAIN 1000
#define STABILIZATION_ATTITUDE_PHI_DGAIN 400
#define STABILIZATION_ATTITUDE_PHI_IGAIN 200
#define STABILIZATION_ATTITUDE_THETA_PGAIN 1000
#define STABILIZATION_ATTITUDE_THETA_DGAIN 400
#define STABILIZATION_ATTITUDE_THETA_IGAIN 200
#define STABILIZATION_ATTITUDE_PSI_PGAIN 500
#define STABILIZATION_ATTITUDE_PSI_DGAIN 300
#define STABILIZATION_ATTITUDE_PSI_IGAIN 10
#define STABILIZATION_ATTITUDE_PHI_DDGAIN 300
#define STABILIZATION_ATTITUDE_THETA_DDGAIN 300
#define STABILIZATION_ATTITUDE_PSI_DDGAIN 300

#define SECTION_GUIDANCE_V 1
#define GUIDANCE_V_MIN_ERR_Z POS_BFP_OF_REAL(-10.)
#define GUIDANCE_V_MAX_ERR_Z POS_BFP_OF_REAL( 10.)
#define GUIDANCE_V_MIN_ERR_ZD SPEED_BFP_OF_REAL(-10.)
#define GUIDANCE_V_MAX_ERR_ZD SPEED_BFP_OF_REAL( 10.)
#define GUIDANCE_V_MAX_SUM_ERR 2000000
#define GUIDANCE_V_HOVER_KP 150
#define GUIDANCE_V_HOVER_KD 80
#define GUIDANCE_V_HOVER_KI 20
#define GUIDANCE_V_RC_CLIMB_COEF 163
#define GUIDANCE_V_RC_CLIMB_DEAD_BAND 160000

#define SECTION_GUIDANCE_H 1
#define GUIDANCE_H_MAX_BANK 0.34906585
#define GUIDANCE_H_PGAIN 50
#define GUIDANCE_H_DGAIN 100
#define GUIDANCE_H_AGAIN 100
#define GUIDANCE_H_IGAIN 20

#define SECTION_SIMULATOR 1
#define NPS_ACTUATOR_NAMES {"front_motor", "back_motor", "right_motor", "left_motor"}
#define NPS_INITIAL_CONDITITONS "reset00"
#define NPS_SENSORS_PARAMS "nps_sensors_params_default.h"

#define SECTION_AUTOPILOT 1
#define MODE_MANUAL AP_MODE_ATTITUDE_DIRECT
#define MODE_AUTO1 AP_MODE_HOVER_Z_HOLD
#define MODE_AUTO2 AP_MODE_NAV

#define SECTION_BAT 1
#define CATASTROPHIC_BAT_LEVEL 9.3
#define CRITIC_BAT_LEVEL 9.6
#define LOW_BAT_LEVEL 9.7
#define MAX_BAT_LEVEL 12.4


#endif // AIRFRAME_H
